clear all;  clc;
colores={'+m','*c','xr','sg','db','vk','vm','pc','hr','>g','<b','+k','*m','xc','sr','dg','^b','vk','pm','hc','>r','<g','+b','*k','xm','sc','dr','^g','vb','pk','hm','>c','<r','hg','xk','>m','^c','hb','^m','<c','<m'};

%rand('state',Inf);% Random generator initialization

fprintf('File Loading \n\n');
tic % Starts Time Lapse
coordenadas=[];     demandas=[];    coordenadas_norm=[];
% ========================================================================
archivo='DONI1.dat'; %Name of CCCP Instance
% ========================================================================

% Parameters for testing:
% errores - Error for EXPECTATION-MAXMIZATION, it can be a vector
% NEXP - Iterations of EXPECTATION-MAXIMIZATION
% WGREEDY - Iterations of Greedy Algorithm

errores=[0.5]; % Error for EM
NEXP = 20;
WGREEDY=100;

[datos] = textread(archivo,'%s','delimiter','\n');  [clientes, pmedianas] = strread(datos{1},'%d %d');
for i=2:length(datos)
    [x, y, capacidad, d]= strread(datos{i},'%f %f %d %d');   
    coordenadas(i-1,1)=x;
    coordenadas(i-1,2)=y;
    demandas(i-1)=d;
end
fprintf('File Name = %s,  Capacity = %d,  Clusters = %d\n\n',archivo,capacidad,pmedianas);
coordenadas_originales=[];      coordenadas_originales=coordenadas;

fprintf('Starts [compression] of coordinates [original]\n\n');
coordenadas_comprimidas=compress(coordenadas);

fprintf('Starts [normalization] of coordinates [original compressed]\n\n');
coordenadas_EM=normalize(coordenadas_comprimidas);

fprintf('Obtention of [statistics] from coordinates [original normalized compressed]\n\n');
[xmin,ymin,xmax,ymax,d_media,d_desv,min_dist,max_dist]=statistics(coordenadas_EM);

fprintf('Perform of [Expectation Maximization] with coordinates [original normalized compressed] with [statistics]\n\n');   
fprintf('============== E M ===============\n');

% EM is performed NEXP times to minimize the coefficient of variability CV
CV_ref=Inf; no_best=0;

for r=1:length(errores)
    no_best=0;
    e_min=errores(r)
    while no_best <= NEXP     
        [asignaciones,demandas_acumuladas,CV,ceros] = expmax(coordenadas_EM,pmedianas,xmin,xmax,ymin,ymax,e_min,capacidad,demandas); 
        fprintf('Iteration no_best = %d, CV = %1.4f \n',no_best,CV);
        demandas_acumuladas;
        if CV<CV_ref && ceros==0
            fprintf('ok \n',no_best,CV_ref);
            CV_ref=CV;
            no_best=0;
            asignaciones_best=[];
            demandas_acumuladas_best=[];
            asignaciones_best=asignaciones;
            demandas_acumuladas_best=demandas_acumuladas;
        else
            no_best=no_best+1;
        end
    end
end
fprintf('CV = %1.4f \n',CV_ref);

fprintf('==================================\n\n');
fprintf('Computation of initial [centroids] for [assignments] of [Expectation Maximization] [without Capacity] \n\n');

centroides=[];
for i=1:pmedianas
    clientes_asignados=[];
    for j=1:length(asignaciones_best)
        if asignaciones_best(j)==i 
            clientes_asignados=[clientes_asignados;coordenadas_originales(j,:)];
        end
    end
    nuevo_centro=[ sum(clientes_asignados(:,1))/length(clientes_asignados(:,1)) sum(clientes_asignados(:,2))/length(clientes_asignados(:,1))];
    centroides=[centroides;nuevo_centro(1) nuevo_centro(2)];
end

%==========================================
fprintf('==================================\n\n');
fprintf('Initial adjustment of [assignments] considering [Capacity] for cluster which do not comply restrictions \n\n');

for cont=1:10
demandas_acumuladas=[];
demandas_acumuladas=zeros(1,pmedianas);
for i=1:length(asignaciones_best)
    planta=asignaciones_best(i);
    demandas_acumuladas(planta)=demandas_acumuladas(planta)+demandas(i);
end
asignaciones_best=funcapacity(demandas_acumuladas,capacidad,centroides,asignaciones_best,coordenadas_originales,demandas);
demandas_acumuladas=[];
demandas_acumuladas=zeros(1,pmedianas);
for i=1:length(asignaciones_best)
    planta=asignaciones_best(i);
    demandas_acumuladas(planta)=demandas_acumuladas(planta)+demandas(i);
end
demandas_acumuladas;
fprintf('CV = %1.4f \n',std(demandas_acumuladas)/mean(demandas_acumuladas));
end
%==========================================

fprintf('[Greedy] routine for [re-adjustment] of [assigments] [with Capacity] \n\n');

% This Greedy process gathers the closest clients to each centroid obtained with EM. Here we consider the capacity constraint.
Cota=Inf;
W=0;
fprintf('Greedy iteration %d with Objective Function = %1.5f \n',W, Cota);

for W=1:WGREEDY
    [asignaciones_best,demandas_acumuladas]=funcapacity2(capacidad,centroides,asignaciones_best,coordenadas_originales,demandas);
    if find(demandas_acumuladas>capacidad)>0
        fprintf('error %d\n',find(demandas_acumuladas>capacidad));
        error=1;
    else
        error=0;
    end
    centroides=[];
    distancias_plantas=[];    
    for i=1:pmedianas
        clientes_asignados=[];
        for j=1:length(asignaciones_best)
            if asignaciones_best(j)==i 
                clientes_asignados=[clientes_asignados;coordenadas_originales(j,:)];
            end
        end
        nuevo_centro=[ sum(clientes_asignados(:,1))/length(clientes_asignados(:,1)) sum(clientes_asignados(:,2))/length(clientes_asignados(:,1))];
        suma_dist=0;
        for j=1:length(clientes_asignados(:,1))
            suma_dist=suma_dist+sqrt((nuevo_centro(1)-clientes_asignados(j,1))^2+(nuevo_centro(2)-clientes_asignados(j,2))^2);
        end        
        centroides=[centroides;nuevo_centro(1) nuevo_centro(2)];
        distancias_plantas=[distancias_plantas;suma_dist];
    end
    referencia=sum(distancias_plantas);
    if referencia <= Cota && error==0
        Cota=referencia;
        mejor_asignacion_Greedy=[];
        mejor_centroides_Greedy=[];
        mejor_asignacion_Greedy=asignaciones_best;
        mejor_centroides_Greedy=centroides;
    end
    fprintf('Greedy iteration %d with Objective Function = = %1.5f \n',W, Cota);
end

tiempo=toc % Ends Time Lapse

mejor_asignacion_Greedy=mejor_asignacion_Greedy';

[suma,suma_demandas,suma_asignaciones,no_cumplen,pertenencias]=verify(archivo,mejor_asignacion_Greedy,mejor_centroides_Greedy);