function  [asignaciones,demandas_acumuladas,CV,ceros] = expmax(coordenadas,pmedianas,xmin,xmax,ymin,ymax,e_min,capacidad,demandas)

ciclos = 10;

X=[];
X=coordenadas';
N=length(X(1,:));

e=Inf;

% EXPECTATION MAXIMIZATION
% Starts iterative Expectation Maximization process
%Parameter initialization:  ========================================  
m_0=[];
S_0=[];
Se_0=[];
P_0=[];
Ynk=[];
     
for i=1:pmedianas
    mx=[unifrnd(xmin,xmax) unifrnd(ymin,ymax)]';
    m_0=[m_0 mx];
    S_0(i)=unifrnd(0,0.1); %Covariance matrix random initialization
end

for i=1:pmedianas
    Se_0(:,:,i)=S_0(i)*eye(length(m_0(:,i)));
    P_0(i)=1/rand;
end

suma=sum(P_0);

P_0=P_0/suma;

%======================================================================

iteracion = 0;
    
while e > e_min && iteracion <= ciclos    
    % START THE EXPECTATION STAGE: ====================================
    for k=1:N
        %Evaluate probability of each vector in each Gaussian component
        vec=[];
        vec=X(:,k);
        z=[];
        for j=1:length(P_0)
            z=[z (1/(sqrt(2*pi)*det(Se_0(:,:,j))^(0.5)))*exp(-0.5*((vec-m_0(:,j))'*inv(Se_0(:,:,j))*(vec-m_0(:,j))))];
        end
        P_tot=z*P_0';
        for j=1:length(P_0)
            Ynk(j,k)=(z(j)*P_0(j))/P_tot;
        end
    end
    Q=0;
    for k=1:N
        for j=1:length(P_0)
            Q=Q+Ynk(j,k)*(-(length(m_0(:,1))/2)*log(2*pi*S_0(j))-sum((X(:,k)-m_0(:,j)).^2)/(2*S_0(j))+log(P_0(j)));
        end
    end
    
    % BEGIN MAXIMIZATION STAGE: ===================================
    % Determine the new means
    m_n=[];
    S_n=[];
    P_n=[];
    for j=1:length(P_0)
        a=zeros(1,length(m_0(:,1))); % vector where I am going to save the cumulative of X by its probability Ynk
        for k=1:N
            a = a + Ynk(j,k)*(X(:,k)'); %X must be a row vector
        end
        m_n(:,j)=a/sum(Ynk(j,:));
    end
    
    % Determine the variances
    for j=1:length(P_0)
        b=0;
        for k=1:N
            % X and m must be as row vectors
            b = b+Ynk(j,k)*((X(:,k)'-m_n(:,j)')*(X(:,k)'-m_n(:,j)')');
        end
        S_n(j)=b/(length(P_0)*sum(Ynk(j,:)));
        if S_n(j)<10^(-10)
            S_n(j)=0.001;
        end
    end
    
    % Determine the probabilities of each component
    for j=1:length(P_0)
        q=0;
        for k=1:N
            q=q+Ynk(j,k);
        end
        P_n(j)=q/N;
    end
    
    %I calculate the error
    e=sum(abs(P_n-P_0))+sum(sum(abs(m_n-m_0)))+sum(abs(S_n-S_0));
    demandas_acumuladas=zeros(1,pmedianas);
    asignaciones=[];
    for j=1:length(demandas)
        vec=[];
        vec=Ynk(:,j);
        a=find(vec>=max(vec));
        asignaciones(j)=a;
        demandas_acumuladas(a)=demandas_acumuladas(a)+demandas(j);
    end
    demandas_acumuladas;
    
    if length(find(demandas_acumuladas==0))>0
        ceros=1;
    else
        ceros=0;
    end

    CV=std(demandas_acumuladas)/mean(demandas_acumuladas);

    %Update for next iteration
    P_0=P_n;
    m_0=m_n;
    S_0=S_n;

    Se_0=[];
    
    for pp=1:pmedianas
        Se_0(:,:,pp)=S_0(pp)*eye(length(m_0(:,pp)));
    end
    iteracion=iteracion+1;
end










