function asignaciones=funcapacity(demandas_acumuladas,capacidad,centroides,asignaciones,coordenadas,demandas)

pmedianas=length(demandas_acumuladas);
no_cumplen=[];
no_cumplen=find(demandas_acumuladas>=capacidad);

cumplen=[];
cumplen=find(demandas_acumuladas<capacidad);

% The process focuses only on plants or centers (centroids) that do not meet capacity restrictions
for i=1:length(no_cumplen)
    planta=no_cumplen(i);
    coord_planta=centroides(planta,:); %Loads the coordinate (x, y) of the i-th plant/centroid that does not comply
    for j=1:length(asignaciones)
        a=asignaciones(j);
        % First, the original distance between a point assigned to the non-compliant plant and the plants that have available capacity is calculated
        % (these are, that they DO comply) to see if this point is closer to another plant that has availability.
        % This is evaluated for each originally assigned customer.
        if a==planta % It is time to evaluate the client assigned to the plant that does not comply
            dist_orig= sqrt((coordenadas(j,1)-coord_planta(1))^2 + (coordenadas(j,2)-coord_planta(2))^2);     
            distancias_t=[];
            distancias_t=zeros(1,length(cumplen)); % The distances from this point are evaluated with respect to all the plants that DO comply
            for k=1:length(cumplen)
                planta_prueba=[];
                vv=cumplen(k);
                planta_prueba=centroides(vv,:);
                if demandas_acumuladas(vv)+demandas(j) <= capacidad
                    distancias_t(k)=sqrt((coordenadas(j,1)-planta_prueba(1))^2 + (coordenadas(j,2)-planta_prueba(2))^2);
                else
                    distancias_t(k)=Inf; % If there is available capacity the distance is calculated, if not, it is set to Inf
                end
            end
            mejores_plantas=[];
            temp=[]; 
            temp=sort(distancias_t);
            % =========
            if length(temp)>0
                % ========= 
                ref_0=temp(1);
                mejores_plantas=find(distancias_t<=ref_0);
                if length(mejores_plantas)>0 
                    b=mejores_plantas(ceil(unifrnd(0,length(mejores_plantas))));
                    if demandas_acumuladas(planta)-demandas(j) >= ceil(sum(demandas)/pmedianas)
                        asignaciones(j)=cumplen(b);
                        demandas_acumuladas(cumplen(b))=demandas_acumuladas(cumplen(b))+demandas(j);
                        demandas_acumuladas(planta)=demandas_acumuladas(planta)-demandas(j);
                    else
                        asignaciones(j)=asignaciones(j);
                    end
                else
                    asignaciones(j)=asignaciones(j);
                end
                %==========
            else
                %Do nothing
            end
            %===========
        end
    end
end

% Recalculation of accumulated demands with new assignments

demandas_acumuladas=[];

demandas_acumuladas=zeros(1,pmedianas);

for i=1:length(asignaciones)
    planta=asignaciones(i);
    demandas_acumuladas(planta)=demandas_acumuladas(planta)+demandas(i);
end
